
////////////////////////////////////////////////////////////////////////////
//  Name    : zegar.c                                               	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2003	                                      //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2003-03-25                                                  //
//  Version : 1.0    OK.27.03.03                                          //
//  Notes   :realizacja zegara programowego z odliczaniem dni,miesiecy,lat//                                                                       //
// 			z uwzglednieniem lat przestepnych
////////////////////////////////////////////////////////////////////////////
const byte dni_mies[13]={0,31,28,31,30,31,30,31,31,30,31,30,31};//ilosc dni w miesiacach

int sek, min, godz, dni, mies, lata,lata_,min_,godz_,dni_,mies_;

//************************************************************************//
//                                                                        //
//************************************************************************//
time_init()
{
sek=0;min=0;godz=0;dni=1;mies=1;lata=0;		//ustaw poczatkowy czas i date

}
//************************************************************************//

//**************************************************************************//
// obsuga tmr1																//
// przerwanie nastepuje co 1s dla kwarcu 32,768 							//
//**************************************************************************//
#int_timer1
void tmr1()
{int ile_dni,i;
bit_set(tmr1h,7);				//dodaj do licznika 32,768

//jesli dzien=2, to sprawdz, czy rok jest przestepny, jesli tak to luty=29
i=lata&0b00000011;
if(mies==2&&i==0) ile_dni=29;	//w ile_dni jest zapisana max wartosc dni w danym miesiacu
else ile_dni=dni_mies[mies];	//jesli miesiac inny niz luty i przestepny
								//to odczytaj liczbe dni z tablicy

if(++sek>59)					//jesli sek>59 to zeruj i zwieksz minuty
  {sek=0;
  if(++min>59)					//jesli zwiekszone minuty sa wieksze od 59
	{min=0;						//to zeruj i zwieksz godziny
	if(++godz>23)				//jesli zwiekszone godziny sa wieksz od 23
	  {godz=0;					//to zeruj i zwieksz liczbe dni miesiaca
	  if(++dni>ile_dni)			//jesli zwiekszona liczba dni jest wieksza niz
		{dni=1;					//dopuszczalna w danym miesiacu do dni=1 i zwieksz
	     if(++mies>12)			//miesiace, jesli zwiekszone iesiace sa>12,
	 	   {mies=1;				//to miesiace=1 i zwieksz lata,
	 	   if(++lata>99) lata=0;// jesli zwiekszone lata sa wieksze niz 99,
	 	   }					//zeruj lata
	 	 }
	   }
	  }
    }
if(++temp_status>3)
		temp_status=0;			//licznik wykorzystywany do pomiaru temperatury
}
//***************************************************************************//

//************************************************************************//
//Procedura ustawia aktualny czas zegara		                          //
//godz,min,sek,dzien,mies,rok
//************************************************************************//
UstawCzas()
{	int buf,dnibuf,i;

	lcd_eeprom_text(ustawianie);			//odczytaj z eeprom tekst i wpisz na LCD
//	lcd_putc("\r  Ustawianie czasu\n");		//to samo odczytywane z pamieci programu
//	lcd_putc("gg:mm:00  DD-MM-2000");
	lcd_gotoxy(2,20);
	lcd_putc(cursorOn);						//wlacz kursor
	while(get_key()==ok);					//czekaj na zwolnienie klawisza OK
	key=10;
//-------------------------------------------------------------------
//ustawianie roku
	buf=lata;
	while(key!=ok)
		{
		if(Key>0)
			{if(key==esc) return;
			if(key==up)
				if(++buf==100) buf=0;
			 if(key==down)
				if(--buf==255) buf=99;
			 delay_ms(200);
			 lcd_gotoxy(2,19);
			 lcd_putdec(buf);
			 lcd_gotoxy(2,20);

		 	}
		 get_Key();
		}
		lata_=buf;
//----------------------------------------------------------------
//ustawianie miesiaca
while(get_Key()==ok);
buf=mies;
key=10;
while(key!=ok)
		{
		if(Key>0)
			{if(key==esc) return;
			if(key==up)
				if(++buf==13) buf=1;
			 if(key==down)
				if(--buf==0) buf=12;
			 delay_ms(200);
			 lcd_gotoxy(2,14);
			 lcd_putdec(buf);
			 lcd_gotoxy(2,15);
		 	}
		 get_Key();
		}
		mies_=buf;
//------------------------------------------------------------------------
//ustawianie dnia
while(get_Key()==ok);
//jesli dzien=2, to sprawdz, czy rok jes przestepny, jesli tak to luty=29
	i=lata_&0b00000011;
	if(mies_==2&&i==0) dnibuf=29;
	else dnibuf=(dni_mies[mies_]);		//jesli miesiac inny niz luty i przestepny
//----------------------------------------------------------------------
buf=dni;
key=10;
while(key!=ok)
		{
		if(Key>0)
			{if(key==esc) return;
			if(key==up)
				if(++buf>dnibuf) buf=1;
			 if(key==down)
				if(--buf==0) buf=dnibuf;
			 delay_ms(200);
			 lcd_gotoxy(2,11);
			 lcd_putdec(buf);
			 lcd_gotoxy(2,12);
		 	}
		get_Key();
		}
		dni_=buf;
/////////////////////////////////////////////////////////////////////////////
//ustawianie godziny
while(get_Key()==ok);
buf=godz;
key=10;
while(key!=ok)
		{
		if(Key>0)
			{if(key==esc) return;
			if(key==up)
				if(++buf==24) buf=0;
			 if(key==down)
				if(--buf==255) buf=23;
			 delay_ms(200);
			 lcd_gotoxy(2,1);
			 lcd_putdec(buf);
			 lcd_gotoxy(2,2);
		 	}
		get_Key();
		}
		godz_=buf;
//ustawianie minut
while(get_Key()==ok);
buf=min;
key=10;
while(key!=ok)
		{
		if(Key>0)
			{if(key==esc) return;
			if(key==up)
				if(++buf==60) buf=0;
			 if(key==down)
				if(--buf==255) buf=59;
			 delay_ms(200);
			 lcd_gotoxy(2,4);
			 lcd_putdec(buf);
			 lcd_gotoxy(2,5);
		 	}
		get_Key();
		}
		min_=buf;
sek=0;
min=min_;godz=godz_;dni=dni_;mies=mies_;lata=lata_;
set_timer1(timer1_set);					//ustaw poczatkowa wartosc Tmr1
}
//************************************************************************//
