#include <16c84.h>
typedef unsigned char uchar;
#include "pwzm.h"
#bit RS = porta.0
#bit EN = porta.1
#bit ID = porta.2
#bit DATA = porta.4
#bit CLK = porta.3
uchar klawiatura_vol()
{
uchar port,kod;
	while((portb&0xf0)!=0xf0);
	delay_ms(50);
	while((portb&0xf0)==0xf0);
	port=portb;
	port=port>>4;
	port=~port;
	kod=port&0x0f;
	if(kod==4||kod==8)
	{delay_ms(80);
	return(kod);}
	while((portb&0xf0)!=0xf0);
	return(port&0x0f);
}

void main()
{
uchar pom;

	set_tris_a(0);
	set_tris_b(0xf0);
	fs_inicLCD();
	delay_ms(200);
	zapisLMC(0x46,5);
	zapisLMC(0x40,read_eeprom(inp));
	zapisLMC(0x41,read_eeprom(lou));
	zapisLMC(0x42,read_eeprom(bas));
	zapisLMC(0x43,read_eeprom(tre));
	zapisLMC(0x44,read_eeprom(vol));
	zapisLMC(0x45,read_eeprom(vol));

	while(1){
	pozycja(0);
	wysLCD("Volume -");
	pozycja(0x40);
	wysLCD("  dB In ");
	wys_dzies((read_eeprom(vol)*2),0x40);
	pozycja(0x47);
	zapis_rd(read_eeprom(inp)+0x31);
	pom=klawiatura_vol();
	if(pom==2)//klawisz funkcji
	{wyk_funkcji();//menu funkcji
	 continue;}
	else
	if(pom==4)//volume -
	{reg_vol(0);
	continue;}
	else
	if(pom==8)//volume +
	{reg_vol(1);
	continue;}
	else
	if(pom==1)//przelaczanie wejscia
	{pom=read_eeprom(inp);
	pom=pom+1;
	if(pom==3)
	pom=0;
	pozycja(0x47);
	zapis_rd(pom+0x31);
	zapisLMC(0x40,pom);
	zapis_eeprom(inp,pom);
	continue;}
	}
}
void reg_vol(char kierunek)
{
char volume;

	volume=read_eeprom(vol);
	while(1){
	if(kierunek==0)
	{if(volume==40)
	 break;
	 else
	volume=volume+1;
	zapisLMC(0x44,volume);
	zapisLMC(0x45,volume);}//wyciszanie
	else
	{if(volume==0)
	break;
	 else
	volume=volume-1;
	zapisLMC(0x44,volume);
	zapisLMC(0x45,volume);}//glosniej
	wys_dzies((volume*2),0x40);
	if((portb&0xf0)==0xf0)
	break;
	delay_ms(140);}
	zapis_eeprom(vol,volume);
	delay_ms(30);

}
void wyk_funkcji()
{
char funkcja,kl;
	funkcja=read_eeprom(fun);
	wys_funkcji();//wyswietlenie oststnio wykonywanej funkcji
	while(1){
	kl=klawiatura();
	if(kl==2)//klawisz f wybor funkcji
	{funkcja=funkcja+1;
	if(funkcja==3)
	funkcja=0;
	zapis_eeprom(fun,funkcja);
	wys_funkcji();
	continue;}
	else//przycisniecie klawisza innego niz f
	break;
	}
	if(funkcja==0||funkcja==1)
	 reg_ton(funkcja);//regulacja tonow
	else
	ust_kontur();//funkcja kontur
}
//wyswietlenie funkcji
void wys_funkcji()
{
	pozycja(0x40);
	wysLCD("        ");
	pozycja(0);
	switch(read_eeprom(fun)){
	case 0:
	wysLCD("Bass    ");
	return;
	case 1:
	wysLCD("Treble  ");
	return;
	case 2:
	wysLCD("Loud    ");
	return;
	default:
	break;}
}

void reg_ton(char rodz)
{
char ton,tonp;
	pozycja(0x40);
	wysLCD("  dB");
	if(rodz==0)//tony niskie
	{ton=read_eeprom(bas);}
	else
	{ton=read_eeprom(tre);}
	if(ton>12)
	ton=0;
	 while(1){
	 if(rodz==0)
	 zapisLMC(0x42,ton);
	 else
	 zapisLMC(0x43,ton);
	 tonp=tony[ton];//wartosc do wyswietlenia z tablicy
	 wys_dzies(tonp,0x40);//wyswietlenie w postaci dziesietnej
	 pozycja(7);
	 if(ton<7)//znak regulacji
	 zapis_rd('-');
	 else
	 if(ton>=7)
	 zapis_rd('+');

	 tonp=klawiatura();//ustwianie wartosci
	 if(tonp==8)//+
	 {ton=ton+1;
	  if(ton==13)
	  ton=12;
	  continue;}
	 else
	 if(tonp==4)//-
	 {ton=ton-1;
	  if(ton==0xff)
	  ton=0;
	  continue;}
	 else
	 if(tonp==2)//F
	 break;
	 }
	 if(rodz==0)
	 zapis_eeprom(bas,ton);//zapisanie ustawien do eepromu
	 else
	 zapis_eeprom(tre,ton);


}

void ust_kontur()
{
char pom;
	pom=read_eeprom(lou);//ustawienia konturu
	while(1){
	pozycja(5);
	if(pom==0)
	zapis_rd('N');
	else
	zapis_rd('Y');
	if(klawiatura()==2)//klawisz F
	break;
	pom=pom+1;
	pom=pom&1;
	zapisLMC(0x41,pom);

	}
	zapis_eeprom(lou,pom);//zapis ustawien do eepromu

}
void zapis_eeprom(uchar adr,uchar dana)
{
	EEADR=adr;
	EEDATA=dana;
	//GIE=0;
	WREN=1;
	EECON2=0x55;
	EECON2=0xaa;
	WR=1;
	while(WR==1);
	//GIE=1;
	//write_eeprom(adr,dana);
}
void wys_dzies(char wartosc,char poz)
{
char ldzies,ljedn;
	pozycja(poz);
	ldzies=wartosc/10;
	zapis_rd(ldzies+0x30);
	ldzies=ldzies*10;
	wartosc=wartosc-ldzies;
	zapis_rd(wartosc+0x30);

}
void zapisLMC(uchar adres, uchar dana)
{
	ID=0;//zapis adresu
	delay_us(1);
	doLMC(adres);
	ID=1;//zapis danej
	delay_us(1);
	doLMC(dana);
	delay_us(6);
	ID=0;
	delay_us(3);
	ID=1;
	delay_us(10);
}
void doLMC(uchar bajt)
{
uchar i;
	for(i=0;i<8;i++)
	{CLK=0;
	 if((bajt&1)==1)
	 DATA=1;
	 else
	 DATA=0;
	 CLK=1;
	 bajt=bajt>>1;}
}
uchar klawiatura()
{
uchar port;

	while((portb&0xf0)==0xf0);
	delay_ms(80);//80msek na drgania stykow
	port=portb;
	port=port>>4;
	port=~port;
	while((portb&0xf0)!=0xf0);
	return(port&0x0f);
	delay_ms(20);
}

void wysLCD(char *napis)
{
	 zapis_rd(napis);
}

void fs_inicLCD()		//inicjalizacja modulu LCD
{
        EN=0;
        delay_ms(50);
	zapis_ri_inic(3);
	delay_ms(6);
        zapis_ri_inic(3);
	delay_ms(6);
      	zapis_ri_inic(3);
	delay_ms(6);
	zapis_ri_inic(3);
	delay_ms(6);

	zapis_ri(0x28);
	zapis_ri(8);//display off
	zapis_ri(1);//display clear
	zapis_ri(6);//entry mod
	zapis_ri(0x0c);//display on
				}
void zapis_ri_inic(uchar regi)
{

    	RS=0;
	portb=regi;
    	EN=1;
	delay_cycles(4);
    	EN=0;

}
void pozycja(uchar poz)
{
 	 RS=0;
  	 zapis(poz|0x80);//zapisz adres

}
void zapis_rd (uchar znak)
{
	RS=1;
	zapis(znak);
}
void zapis_ri(uchar regi)
{

       RS=0;	//rejestr I
       zapis(regi);
}
void zapis(uchar rejestr)
{
char pom;

       delay_ms(2);
       portb=rejestr>>4;//starsza czesc
       EN=1;		//wybranie
       delay_cycles(3);
       EN=0;		//nie wybrany
       portb=rejestr;//mlodsza czesc
       EN=1;
       delay_cycles(3);
       EN=0;

}
