//mapa pamieci eeprom
//0- numer funkcji 
//1- vol 1,2 
//2- vol 3,4
//3- bass
//4- treble
//5- surround bit b0 surr1, bit b1 surr2
//6- stereo/quadro bit b0=0 tryb stereo b0=1 tryb quadro
//7- temperatura 1
//8- temperatura 2
//9- temporary vol 3,4
#fuses XT,NOWDT,PUT,NOPROTECT
#use delay (clock=2000000)
#use i2c (master, sda=PIN_C4, scl=PIN_C3, slow )
#locate porta=5
#locate portb=6
#locate portc=7
#bit SA = portb.4
#bit SB = portb.3
#bit kl = portb.6
#bit RS = porta.5
#bit EN = porta.4
#bit CLK1=portb.0
#bit LATCH1=portb.1
#bit CLK2=portc.5
#bit LATCH2=portc.7
#bit R_WYSW=portb.7
#bit LED_Q=portb.5
#bit LED_S=portc.1
#bit inp=portc.0
#bit alm=portc.2
int temp_alm;
const int tab_vol[]={0xff,0xe5,0xdb,0xd3,0xcc,0xc6,0xc0,0xba,0xb5,0xb0,0xab,0xa7,0xa3,0x9f,0x9c,0x98,0x95,0x91,0x8e,0x8a,0x87,0x81,0x7b,0x75,0x70,0x6b,0x66,0x62,0x5d,
0x59,0x55,0x51,0x4d,0x4a,0x47,0x43,0x40,0x3d,0x3a,0x37,0x34,0x32,0x2f,0x2d,0x2b,
0x28,0x26,0x24,0x23,0x21,0x1f,0x1e,0x1c,0};
const int tab_vol_disp[]={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,22,24,26,28,30,32,34,36
38,40,42,44,46,48,50,52,54,56,58,60,62,64,66,68,70,72,74,76,78,80,82,84};
const int tab_tone_t[]={0,4,6,8,9,0x0a,0x0b,0x0c,0x0f,0x14,0x15,0x16,0x17,0x18,0x1a,0x1c,0x1f};
const int tab_tone_b[]={0,5,7,9,0x0a,0x0b,0x0c,0x0d,0x0f,0x13,0x14,0x16,0x16,0x17,0x19,0x1b,0x1f};
const int tab_tone_disp[]={0x8c,0x8a,0x88,0x86,0x84,0x82,0,2,4,6,8,10,12};
void send_vfd(int d_disp);
void inic_vfd();
void poz_vfd(int adres);
void wys_vfd(int napis);
void wr_cmd(int cmd);
void dane_lcd(int dana);
void inic_lcd();
void wr_cmd(int cmd);
void wr_data(int data);
void wr_lcd(int dana);
void wysLCD(char napis);
void pozycja(int poz);
void wr_cmd(int cmd);
void dane_lcd(int dana);
void inic_lcd();
void wr_cmd(int cmd);
void wr_data(int data);
void wr_lcd(int dana);
void wysLCD(int napis);
void pozycja(int poz);
void send_audio(int nr_p);
void audio();
void wr_eeprom(int adres,int dana);
int rd_eeprom(int adres);
int impulsator();
void wys_dzies(int wartosc,int poz);
void wys_hex(int wartosc,int poz);
void def_font();
void wys_fun(int nr_fun);
void sel_fun();
void wyk_vol12();
void wyk_vol34();
void wyk_bass();
void wyk_treble();
void wyk_surr1();
void wyk_surr2();
void wyk_mo_qu();
void wyk_temp1();
void wyk_temp2();
void set_temp_config();
int read_temp();
void termometr();
void send_temp(int temp,int adres);
void set_temp(int1 rt,int16 temp);
