///////////////////////////////////////////////////////////////////////////
//  Name    : Odbiornik_RC5_SIRC.c                                   	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2003	                                      //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 			                                                  //
//  Version : 1.0                                                         //
//  Notes   :                                                             //
//          :                                                             //
////////////////////////////////////////////////////////////////////////////
#include <12f675.h>
#include <f675.h>
// 	BG1	BG0	 NC   NC  NC  CPD  CP BODEN MCLR PWRTE WDTE FOSC2 FOSC1 FOSC0
//  13  12   11   10   9   8   7    6    5    4     3     2   1      0
//   1	 1    0	   0   0   1   1    1    0    0     1     0   0      1
//  BG-HVolt             OFF  OFF   ON  PIN  ON    OFF   XT

#rom 0x2007={0b11000111000001}							//

#use delay(clock=4000000)								//
#use rs232(baud=9600, xmit=PIN_a0)  					//
#id 0,4,0,3				        						//
#include <int_sony_rc5_rx.h>	    					//obsluga RC5 i Sony w przerwaniu
#define JP gpio_1										//pin dolaczonej zworki JP
////////////////////////////POCZATEK MAIN////////////////////////////////////
main()
{int i;
	cmcon=7;											//porta jako cyfrowy
	pcon=0;
	bit_clear(option_reg,not_gppu);						//podciaganie globalne
	WPU=0b00000110;										//pullup dla gp1 i gp2
	ansel=0x00;											//a0...a3->cyfrowe
	trisio=0b11111110;									//gp0 jako wyjscie
	ir_init();											//inicjalizacja odbioru IR
while(1)												//glowna petla
	{
	if(get_ir()>0)										//jesli odebrano kod
		{												//i zworka rozwarta, to
		if(jp)											//wysyla ten kod w pelnym formacie
			{
			if(ir_ok==2) printf("\fSIRC(Sony)");		//jesli kod byl SIRC, to wyswietl Sony
			else if(ir_ok==1) printf("\fRC5(Philips)"); //jesli w RC5, to wyswietl RC5
			printf(" Address=%u  Command=%u", address,command); //oraz odebrany adres i kod
			}
		else											//jesli zworka zwarta, to wyswietl
			{if(ir_ok==2) printf("\fS");				//w postaci skroconej
			else if(ir_ok==1) printf("\fR");
			printf(" A=%u C=%u", address,command);
			}
		ir_init();										//inicjuj odbior kolejnej transmisji
		}

	}
}
/////////////////////////////KONIEC MAIN///////////////////////////////////////


